mod Ex03 logic: 'cl'

incl Mtex

rem 
  3. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 11.3.2004
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  2 TESTY: 60 bodov = 30+30
  FINALTERM: 40 bodov
  PREMIOVE ULOHY
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [2i1,2i2,2i3,2i4]
  PREDNASKA: Jan Komara
  CVICENIA: Jan Komara, Jozef Nagy
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane parovej 
  reprezentacii cisel a zoznamom. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor \it  ex03.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter.  \end \bf  Recursive Bootstrapping of PA.  \end 

rem 
  \para \bf  Section. Suitable Pairing Function.  \end 

rem 
  \para \bf  [CL] Remark.  \end The following properties of the pairing function 
  are built in into the CL theorem prover: 
  \eq* 
    x1,x2 = y1,y2 <-> x1 = y1 & x2 = y2
  \end
  \eq* 
    x,y = 0 <-> \f
  \end
  \para Moreover, we have 
  \eq (occur_check)
    x = Tex2_bappl1(Tex0_tau,x) <-> \f
  \end
  \para for terms \ft Tex2_bappl1(Tex0_tau,x) \end of the form 
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),x,y)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y,x)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),(x,y1),y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),(y1,x),y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y1,x,y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y1,y2,x)
  \end
  \eq* 
    Tex0_dotsc
  \end

rem 
  \para \bf  [CL] Pair case analysis.  \end Syntax: 
  \items 
   \item \para The command \it  case  \end \ft P \end \it  ;  \end 
         \ft Tex0_tau \end invokes pair case analysis on the term 
         \ft Tex0_tau \end. 
  \end
  \para The predicate \ft P \end is defined in the module \ft Standard \end. 

rem 
  \para \bf  [CL] Pair induction.  \end Syntax: 
  \items 
   \item \para The command \it  ind  \end \ft P \end \it  ;  \end \ft x \end 
         invokes pair induction on \ft x \end with the induction formula 
         \ft Tex2_bappl1(Tex0_phi,x) \end, where 
         \ft Tex2_bappl1(Tex0_phi,x) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind  \end \ft P \end \it  ;  \end \ft x \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes pair induction on \ft x \end 
         with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,x,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,x,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

rem 
  \para \bf  Iteration of the second projection.  \end 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Proj2 Iproj2(n,x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Iproj2_mono_zero
    Iproj2(n,0) = 0
  \end
  \eq Iproj2_plus
    Iproj2(m+n,x) = Iproj2(m,Iproj2(n,x))
  \end

thm Iproj2_mono_zero
  Iproj2(n,0) = 0

thm Iproj2_plus
  Iproj2(m+n,x) = Iproj2(m,Iproj2(n,x))

rem 
  \para \bf  Pair size.  \end 

fun Szp 'Tex_f1_pp_sz'
  Szp(0) = 0
  Szp(v,w) = Szp(v)+Szp(w)+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Szp_zero
    Szp(x) = 0 <-> x = 0
  \end
  \eq Szp_one
    Szp(x) = 1 <-> x = 0,0
  \end

thm Szp_zero
  Szp(x) = 0 <-> x = 0

thm Szp_one
  Szp(x) = 1 <-> x = 0,0

rem 
  \para \bf  [CL] Remark.  \end The pair size function \ft |x| \end, written as 
  \it  |x|  \end, is defined in the module \ft Standard \end and the following 
  its properties are built in into the CL theorem prover: 
  \eq* 
    |x| = 0 <-> x = 0
  \end
  \eq* 
    |x| = 1 <-> x = 0,0
  \end

rem 
  \para \bf  Reflection function.  \end 

fun Reflect 
  Reflect(0) = 0
  Reflect(v,w) = Reflect(w),Reflect(v)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Reflect_zero
    Reflect(x) = 0 <-> x = 0
  \end
  \eq Ps_reflect
    |Reflect(x)| = |x|
  \end
  \eq Reflect_reflect
    Reflect Reflect(x) = x
  \end
  \eq Reflect_injective
    Reflect(x) = Reflect(y) -> x = y
  \end
  \eq Reflect_surjective
    \e y Reflect(y) = x
  \end

thm Reflect_zero
  Reflect(x) = 0 <-> x = 0

thm Szp_reflect
  |Reflect(x)| = |x|

thm Reflect_reflect
  Reflect Reflect(x) = x

thm Reflect_injective
  Reflect(x) = Reflect(y) -> x = y

thm Reflect_surjective
  \e y Reflect(y) = x

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Lists.  \end 

rem 
  \para \bf  [CL] List case analysis.  \end Syntax: 
  \items 
   \item \para The command \it  case  \end \ft Ln \end \it  ;  \end 
         \ft Tex0_tau \end invokes list case analysis on the term 
         \ft Tex0_tau \end. 
  \end
  \para The predicate \ft Ln \end is defined in the module \ft Standard \end. 

rem 
  \para \bf  [CL] List induction.  \end Syntax: 
  \items 
   \item \para The command \it  ind  \end \ft Ln \end \it  ;  \end \ft x \end 
         invokes list induction on \ft x \end with the induction formula 
         \ft Tex2_bappl1(Tex0_phi,x) \end, where 
         \ft Tex2_bappl1(Tex0_phi,x) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind  \end \ft Ln \end \it  ;  \end \ft x \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes list induction on \ft x \end 
         with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,x,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,x,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  List length.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq L_zero
    L(x) = 0 <-> x = 0
  \end
  \eq L_iproj2_zero
    Iproj2(L(x),x) = 0
  \end
  \eq L_iproj2_nonzero
    n < L(x) -> Iproj2(n,x) > 0
  \end
  \eq L_szp
    L(x) <= |x|
  \end
  \eq L_surjective
    \e x L(x) = n
  \end

thm L_zero
  L(x) = 0 <-> x = 0

thm L_iproj2_zero
  Iproj2(L(x),x) = 0

thm L_iproj2_nonzero
  n < L(x) -> Iproj2(n,x) > 0

thm L_szp
  L(x) <= |x|

thm L_surjective
  \e x L(x) = n

rem 
  \para \bf  List indexing.  \end 

fun/2 Sub 'Tex_f2_ln_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Sub_expl
    Sub(x,i) = Proj1 Iproj2(i,x)
  \end

thm Sub_expl
  Sub(x,i) = Proj1 Iproj2(i,x)

rem 
  \para \bf  List concatenation.  \end 

fun/2 Conc 'Tex_f2_ln_conc'
  Conc(0,y) = y
  Conc((v,w),y) = v,Conc(w,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Conc_zero
    Conc(x,y) = 0 <-> x = 0 & y = 0
  \end
  \eq Conc_right_zero
    Conc(x,0) = x
  \end
  \eq Conc_assoc
    Conc(x,Conc(y,z)) = Conc(Conc(x,y),z)
  \end
  \eq Conc_cancel_left
    Conc(x,y) = Conc(x,z) -> y = z
  \end
  \eq Conc_cancel_last
    Conc(x,a,0) = Conc(y,b,0) -> x = y & a = b
  \end
  \eq Conc_cancel_right
    Conc(x,z) = Conc(y,z) -> x = y
  \end
  \eq Szp_conc
    |Conc(x,y)| = |x|+|y|
  \end

thm Conc_zero
  Conc(x,y) = 0 <-> x = 0 & y = 0

thm Conc_right_zero
  Conc(x,0) = x

thm Conc_assoc
  Conc(x,Conc(y,z)) = Conc(Conc(x,y),z)

thm Conc_cancel_left
  Conc(x,y) = Conc(x,z) -> y = z

thm Conc_cancel_last
  Conc(x,a,0) = Conc(y,b,0) -> x = y & a = b

thm Conc_cancel_right
  Conc(x,z) = Conc(y,z) -> x = y

thm Szp_conc
  |Conc(x,y)| = |x|+|y|

rem 
  \para \bf  [CL] Remark.  \end The list concatenation function \ft x++y \end, 
  written as \it  x++y  \end, is defined in the module \ft Standard \end and the 
  following its properties are built in into the CL theorem prover: 
  \eq* 
    0++y = y
  \end
  \eq* 
    (v,w)++y = v,w++y
  \end
  \eq* 
    x++y = 0 <-> x = 0 & y = 0
  \end
  \eq* 
    x++0 = x
  \end
  \eq* 
    x++(y++z) = x++y++z
  \end
  \eq* 
    x++y = x++z <-> y = z
  \end
  \eq* 
    x++z = y++z <-> x = y
  \end
  \eq* 
    x++(a,0) = y++(b,0) <-> x = y & a = b
  \end
  \eq* 
    |x++y| = |x|+|y|
  \end
  \eq* 
    x++y = a,0 -> x = a,0 & y = 0 \/ x = 0 & y = a,0
  \end
  \eq* 
    x++(a,y) = a,0 <-> x = 0 & y = 0
  \end
  \eq* 
    x++a++y = a,0 <-> a = 0 & x++y = 0,0
  \end

rem 
  \para \bf  Exercise.  \end 
  \eq L_conc
    L(x++y) = L(x)+L(y)
  \end
  \eq Sub_conc_left
    i < L(x) -> Sub(x++y,i) = Sub(x,i)
  \end
  \eq Sub_conc_right
    i < L(y) -> Sub(x++y,L(x)+i) = Sub(y,i)
  \end
  \eq Conc_nzero
    x != 0 <-> \e y\e a x = y++(a,0)
  \end

thm L_conc
  L(x++y) = L(x)+L(y)

thm Sub_conc_left
  i < L(x) -> Sub(x++y,i) = Sub(x,i)

thm Sub_conc_right
  i < L(y) -> Sub(x++y,L(x)+i) = Sub(y,i)

thm Conc_nzero
  x != 0 <-> \e y\e a x = y++(a,0)

rem 
  \para \bf  List membership.  \end 

pred/2 In1 'Tex_p2_ln_in'
  In1(x,v,w) <- x = v
  In1(x,v,w) <- x != v & In1(x,w)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq In_pair
    In1(x,v,w) <-> x = v \/ In1(x,w)
  \end
  \eq In_conc
    In1(x,y++z) <-> In1(x,y) \/ In1(x,z)
  \end

thm In_pair
  In1(x,v,w) <-> x = v \/ In1(x,w)

thm In_conc
  In1(x,y++z) <-> In1(x,y) \/ In1(x,z)

rem 
  \para \bf  [CL] Remark.  \end The list membership predicate \ft x in y \end, 
  written as \it  x in y  \end, is defined in the module \ft Standard \end and 
  the following its properties are built in into the CL theorem prover: 
  \eq* 
    x in 0 <-> \f
  \end
  \eq* 
    x in v,w <-> x = v \/ x in w
  \end
  \eq* 
    x in y++z <-> x in y \/ x in z
  \end

rem 
  \para \bf  List reversal.  \end 

fun Rev 
  Rev(0) = 0
  Rev(v,w) = Rev(w)++(v,0)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Rev_zero
    Rev(x) = 0 <-> x = 0
  \end
  \eq Rev_conc
    Rev(x++y) = Rev(y)++Rev(x)
  \end
  \eq Rev_rev
    Rev Rev(x) = x
  \end
  \eq Rev_injective
    Rev(x) = Rev(y) -> x = y
  \end
  \eq Rev_surjective
    \e y Rev(y) = x
  \end
  \eq In_rev
    x in Rev(y) <-> x in y
  \end
  \eq Szp_rev
    |Rev(x)| = |x|
  \end
  \eq L_rev
    L Rev(x) = L(x)
  \end

thm Rev_zero
  Rev(x) = 0 <-> x = 0

thm Rev_conc
  Rev(x++y) = Rev(y)++Rev(x)

thm Rev_rev
  Rev Rev(x) = x

thm Rev_injective
  Rev(x) = Rev(y) -> x = y

thm Rev_surjective
  \e y Rev(y) = x

thm In_rev
  x in Rev(y) <-> x in y

thm Szp_rev
  |Rev(x)| = |x|

thm L_rev
  L Rev(x) = L(x)

rem 
  \para \bf  Exercise.  \end 

fun/2 Reva 'Tex_f2_f'
  Reva(0,a) = a
  Reva((v,w),a) = Reva(w,v,a)

rem 
  \para Prove 
  \eq Rev_by_reva
    Rev(x) = Reva(x,0)
  \end

thm Rev_by_reva
  Rev(x) = Reva(x,0)

